--- old/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
+++ new/usr/src/uts/common/io/scsi/targets/sd.c	Mon Aug  5 17:31:49 2019
@@ -8410,123 +8213,23 @@
 	}
 
 spinup_failed:
-
-	/* Uninitialize sd_ssc_t pointer */
-	sd_ssc_fini(ssc);
-
+	/* attach failed, switch to SD_STATE_ATTACH_FAILED */
 	mutex_enter(SD_MUTEX(un));
-
-	/* Deallocate SCSI FMA memory spaces */
-	kmem_free(un->un_fm_private, sizeof (struct sd_fm_internal));
-
-	/* Cancel callback for SD_PATH_DIRECT_PRIORITY cmd. restart */
-	if (un->un_direct_priority_timeid != NULL) {
-		timeout_id_t temp_id = un->un_direct_priority_timeid;
-		un->un_direct_priority_timeid = NULL;
-		mutex_exit(SD_MUTEX(un));
-		(void) untimeout(temp_id);
-		mutex_enter(SD_MUTEX(un));
-	}
-
-	/* Cancel any pending start/stop timeouts */
-	if (un->un_startstop_timeid != NULL) {
-		timeout_id_t temp_id = un->un_startstop_timeid;
-		un->un_startstop_timeid = NULL;
-		mutex_exit(SD_MUTEX(un));
-		(void) untimeout(temp_id);
-		mutex_enter(SD_MUTEX(un));
-	}
-
-	/* Cancel any pending reset-throttle timeouts */
-	if (un->un_reset_throttle_timeid != NULL) {
-		timeout_id_t temp_id = un->un_reset_throttle_timeid;
-		un->un_reset_throttle_timeid = NULL;
-		mutex_exit(SD_MUTEX(un));
-		(void) untimeout(temp_id);
-		mutex_enter(SD_MUTEX(un));
-	}
-
-	/* Cancel rmw warning message timeouts */
-	if (un->un_rmw_msg_timeid != NULL) {
-		timeout_id_t temp_id = un->un_rmw_msg_timeid;
-		un->un_rmw_msg_timeid = NULL;
-		mutex_exit(SD_MUTEX(un));
-		(void) untimeout(temp_id);
-		mutex_enter(SD_MUTEX(un));
-	}
-
-	/* Cancel any pending retry timeouts */
-	if (un->un_retry_timeid != NULL) {
-		timeout_id_t temp_id = un->un_retry_timeid;
-		un->un_retry_timeid = NULL;
-		mutex_exit(SD_MUTEX(un));
-		(void) untimeout(temp_id);
-		mutex_enter(SD_MUTEX(un));
-	}
-
-	/* Cancel any pending delayed cv broadcast timeouts */
-	if (un->un_dcvb_timeid != NULL) {
-		timeout_id_t temp_id = un->un_dcvb_timeid;
-		un->un_dcvb_timeid = NULL;
-		mutex_exit(SD_MUTEX(un));
-		(void) untimeout(temp_id);
-		mutex_enter(SD_MUTEX(un));
-	}
-
+	New_state(un, SD_STATE_ATTACH_FAILED);
+	cv_broadcast(&un->un_suspend_cv);
 	mutex_exit(SD_MUTEX(un));
 
-	/* There should not be any in-progress I/O so ASSERT this check */
-	ASSERT(un->un_ncmds_in_transport == 0);
-	ASSERT(un->un_ncmds_in_driver == 0);
+	devid = DEVI(devi)->devi_devid_str;
+	scsi_fm_ereport_post(un->un_sd, 0,
+	    NULL, "disk.attach-failure", ssc->ssc_uscsi_info->ui_ena,
+	    devid, NULL, DDI_NOSLEEP, NULL,
+	    FM_VERSION, DATA_TYPE_UINT8, FM_EREPORT_VERS0,
+	    DEVID_IF_KNOWN(devid));
 
-	/* Do not free the softstate if the callback routine is active */
-	sd_sync_with_callback(un);
-
-	/*
-	 * Partition stats apparently are not used with removables. These would
-	 * not have been created during attach, so no need to clean them up...
-	 */
-	if (un->un_errstats != NULL) {
-		kstat_delete(un->un_errstats);
-		un->un_errstats = NULL;
-	}
-
-create_errstats_failed:
-
-	if (un->un_stats != NULL) {
-		kstat_delete(un->un_stats);
-		un->un_stats = NULL;
-	}
-
-	ddi_xbuf_attr_unregister_devinfo(un->un_xbuf_attr, devi);
-	ddi_xbuf_attr_destroy(un->un_xbuf_attr);
-
-	ddi_prop_remove_all(devi);
-	sema_destroy(&un->un_semoclose);
-	cv_destroy(&un->un_state_cv);
-
-	sd_free_rqs(un);
-
-alloc_rqs_failed:
-
-	devp->sd_private = NULL;
-	bzero(un, sizeof (struct sd_lun));	/* Clear any stale data! */
-
-	/*
-	 * Note: the man pages are unclear as to whether or not doing a
-	 * ddi_soft_state_free(sd_state, instance) is the right way to
-	 * clean up after the ddi_soft_state_zalloc() if the subsequent
-	 * ddi_get_soft_state() fails.  The implication seems to be
-	 * that the get_soft_state cannot fail if the zalloc succeeds.
-	 */
-#ifndef XPV_HVM_DRIVER
-	ddi_soft_state_free(sd_state, instance);
-#endif /* !XPV_HVM_DRIVER */
-
-probe_failed:
-	scsi_unprobe(devp);
-
-	return (DDI_FAILURE);
+	/* Uninitialize sd_ssc_t pointer */
+	sd_ssc_fini(ssc);
+	SD_ERROR(SD_LOG_ATTACH_DETACH, un, "sd_unit_attach failed: un: %p",
+	    (void *)un);
 }
 
 
@@ -8556,21 +8259,28 @@
 
 	/*
 	 * Fail the detach for any of the following:
-	 *  - Unable to get the sd_lun struct for the instance
-	 *  - A layered driver has an outstanding open on the instance
-	 *  - Another thread is already detaching this instance
-	 *  - Another thread is currently performing an open
+	 * - Unable to get the sd_lun struct for the instance
+	 * - The instance is still attaching
+	 * - Another thread is already detaching this instance
+	 * - Another thread is currently performing an open
+	 *
+	 * Additionaly, if "device gone" flag is not set:
+	 * - There are outstanding commands in driver
+	 * - There are outstanding commands in transport
 	 */
 	devp = ddi_get_driver_private(devi);
-	if ((devp == NULL) ||
-	    ((un = (struct sd_lun *)devp->sd_private) == NULL) ||
-	    (un->un_ncmds_in_driver != 0) || (un->un_layer_count != 0) ||
-	    (un->un_detach_count != 0) || (un->un_opens_in_progress != 0)) {
+	if (devp == NULL || (un = (struct sd_lun *)devp->sd_private) == NULL ||
+	    un->un_detach_count != 0 || un->un_opens_in_progress != 0 ||
+	    (!DEVI_IS_GONE(devi) &&
+	    (un->un_state == SD_STATE_RWAIT ||
+	    un->un_state == SD_STATE_ATTACHING ||
+	    un->un_ncmds_in_driver != 0 ||
+	    un->un_ncmds_in_transport != 0))) {
 		mutex_exit(&sd_detach_mutex);
 		return (DDI_FAILURE);
 	}
 
-	SD_TRACE(SD_LOG_ATTACH_DETACH, un, "sd_unit_detach: entry 0x%p\n", un);
+	SD_TRACE(SD_LOG_ATTACH_DETACH, un, "%s: entry 0x%p\n", __func__, un);
 
 	/*
 	 * Mark this instance as currently in a detach, to inhibit any
@@ -8584,10 +8294,6 @@
 
 	dev = sd_make_device(SD_DEVINFO(un));
 
-#ifndef lint
-	_NOTE(COMPETING_THREADS_NOW);
-#endif
-
 	mutex_enter(SD_MUTEX(un));
 
 	/*
@@ -8601,24 +8307,19 @@
 	}
 
 	/*
-	 * Verify there are NO outstanding commands issued to this device.
-	 * ie, un_ncmds_in_transport == 0.
-	 * It's possible to have outstanding commands through the physio
-	 * code path, even though everything's closed.
+	 * If the attach wasn't successful, some normal cleanup work must not
+	 * be done.
 	 */
-	if ((un->un_ncmds_in_transport != 0) || (un->un_retry_timeid != NULL) ||
-	    (un->un_direct_priority_timeid != NULL) ||
-	    (un->un_state == SD_STATE_RWAIT)) {
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
 		mutex_exit(SD_MUTEX(un));
-		SD_ERROR(SD_LOG_ATTACH_DETACH, un,
-		    "sd_dr_detach: Detach failure due to outstanding cmds\n");
-		goto err_stillbusy;
+		goto no_attach_cleanup;
 	}
 
 	/*
 	 * If we have the device reserved, release the reservation.
 	 */
-	if ((un->un_resvd_status & SD_RESERVE) &&
+	if (!DEVI_IS_GONE(devi) &&
+	    (un->un_resvd_status & SD_RESERVE) &&
 	    !(un->un_resvd_status & SD_LOST_RESERVE)) {
 		mutex_exit(SD_MUTEX(un));
 		/*
@@ -8627,7 +8328,7 @@
 		 */
 		if (sd_reserve_release(dev, SD_RELEASE) != 0) {
 			SD_ERROR(SD_LOG_ATTACH_DETACH, un,
-			    "sd_dr_detach: Cannot release reservation \n");
+			    "%s: cannot release reservation\n", __func__);
 		}
 	} else {
 		mutex_exit(SD_MUTEX(un));
@@ -8684,7 +8385,32 @@
 	sd_rmv_resv_reclaim_req(dev);
 
 	mutex_enter(SD_MUTEX(un));
+	if (un->un_retry_timeid != NULL) {
+		timeout_id_t temp_id = un->un_retry_timeid;
+		un->un_retry_timeid = NULL;
+		mutex_exit(SD_MUTEX(un));
+		(void) untimeout(temp_id);
+		mutex_enter(SD_MUTEX(un));
 
+		if (un->un_retry_bp != NULL) {
+			un->un_retry_bp->av_forw = un->un_waitq_headp;
+			un->un_waitq_headp = un->un_retry_bp;
+			if (un->un_waitq_tailp == NULL)
+				un->un_waitq_tailp = un->un_retry_bp;
+			un->un_retry_bp = NULL;
+			un->un_retry_statp = NULL;
+		}
+	}
+
+	if (DEVI_IS_GONE(SD_DEVINFO(un))) {
+		/* abort in-flight IO */
+		(void) scsi_abort(SD_ADDRESS(un), NULL);
+		/* abort pending IO */
+		un->un_failfast_state = SD_FAILFAST_ACTIVE;
+		un->un_failfast_bp = NULL;
+		sd_failfast_flushq(un, B_TRUE);
+	}
+
 	/* Cancel any pending callbacks for SD_PATH_DIRECT_PRIORITY cmd. */
 	if (un->un_direct_priority_timeid != NULL) {
 		timeout_id_t temp_id = un->un_direct_priority_timeid;
@@ -8697,11 +8423,10 @@
 	/* Cancel any active multi-host disk watch thread requests */
 	if (un->un_mhd_token != NULL) {
 		mutex_exit(SD_MUTEX(un));
-		 _NOTE(DATA_READABLE_WITHOUT_LOCK(sd_lun::un_mhd_token));
 		if (scsi_watch_request_terminate(un->un_mhd_token,
 		    SCSI_WATCH_TERMINATE_NOWAIT)) {
 			SD_ERROR(SD_LOG_ATTACH_DETACH, un,
-			    "sd_dr_detach: Cannot cancel mhd watch request\n");
+			    "%s: cannot cancel mhd watch request\n", __func__);
 			/*
 			 * Note: We are returning here after having removed
 			 * some driver timeouts above. This is consistent with
@@ -8708,7 +8433,7 @@
 			 * the legacy implementation but perhaps the watch
 			 * terminate call should be made with the wait flag set.
 			 */
-			goto err_stillbusy;
+			goto err_remove_event;
 		}
 		mutex_enter(SD_MUTEX(un));
 		un->un_mhd_token = NULL;
@@ -8716,11 +8441,10 @@
 
 	if (un->un_swr_token != NULL) {
 		mutex_exit(SD_MUTEX(un));
-		_NOTE(DATA_READABLE_WITHOUT_LOCK(sd_lun::un_swr_token));
 		if (scsi_watch_request_terminate(un->un_swr_token,
 		    SCSI_WATCH_TERMINATE_NOWAIT)) {
 			SD_ERROR(SD_LOG_ATTACH_DETACH, un,
-			    "sd_dr_detach: Cannot cancel swr watch request\n");
+			    "%s: cannot cancel swr watch request\n", __func__);
 			/*
 			 * Note: We are returning here after having removed
 			 * some driver timeouts above. This is consistent with
@@ -8727,29 +8451,21 @@
 			 * the legacy implementation but perhaps the watch
 			 * terminate call should be made with the wait flag set.
 			 */
-			goto err_stillbusy;
+			goto err_remove_event;
 		}
 		mutex_enter(SD_MUTEX(un));
 		un->un_swr_token = NULL;
 	}
 
-	mutex_exit(SD_MUTEX(un));
-
 	/*
 	 * Clear any scsi_reset_notifies. We clear the reset notifies
 	 * if we have not registered one.
 	 * Note: The sd_mhd_reset_notify_cb() fn tries to acquire SD_MUTEX!
 	 */
+	mutex_exit(SD_MUTEX(un));
 	(void) scsi_reset_notify(SD_ADDRESS(un), SCSI_RESET_CANCEL,
 	    sd_mhd_reset_notify_cb, (caddr_t)un);
 
-	/*
-	 * protect the timeout pointers from getting nulled by
-	 * their callback functions during the cancellation process.
-	 * In such a scenario untimeout can be invoked with a null value.
-	 */
-	_NOTE(NO_COMPETING_THREADS_NOW);
-
 	mutex_enter(&un->un_pm_mutex);
 	if (un->un_pm_idle_timeid != NULL) {
 		timeout_id_t temp_id = un->un_pm_idle_timeid;
@@ -8791,9 +8507,9 @@
 		    (pm_lower_power(SD_DEVINFO(un), 0, SD_PM_STATE_STOPPED(un))
 		    != DDI_SUCCESS)) {
 			SD_ERROR(SD_LOG_ATTACH_DETACH, un,
-		    "sd_dr_detach: Lower power request failed, ignoring.\n");
+			    "%s: lower power request failed, ignoring\n",
+			    __func__);
 			/*
-			 * Fix for bug: 4297749, item # 13
 			 * The above test now includes a check to see if PM is
 			 * supported by this device before call
 			 * pm_lower_power().
@@ -8856,7 +8572,7 @@
 			 * be the right thing to do.
 			 */
 			SD_ERROR(SD_LOG_ATTACH_DETACH, un,
-			    "sd_dr_detach: Cannot cancel insert event\n");
+			    "%s: cannot cancel insert event\n", __func__);
 			goto err_remove_event;
 		}
 		un->un_insert_event = NULL;
@@ -8871,7 +8587,7 @@
 			 * be the right thing to do.
 			 */
 			SD_ERROR(SD_LOG_ATTACH_DETACH, un,
-			    "sd_dr_detach: Cannot cancel remove event\n");
+			    "%s: cannot cancel remove event\n", __func__);
 			goto err_remove_event;
 		}
 		un->un_remove_event = NULL;
@@ -8880,6 +8596,25 @@
 	/* Do not free the softstate if the callback routine is active */
 	sd_sync_with_callback(un);
 
+no_attach_cleanup:
+	/*
+	 * The driver must wait, at least attempt to wait, for any commands
+	 * still in the driver.
+	 */
+	mutex_enter(SD_MUTEX(un));
+
+	while (un->un_ncmds_in_driver != 0) {
+		clock_t max_delay = ddi_get_lbolt() + SEC_TO_TICK(30);
+		un->un_f_detach_waiting = 1;
+		if (cv_timedwait(&un->un_detach_cv, SD_MUTEX(un),
+		    max_delay) == -1) {
+			break;
+		}
+	}
+
+	un->un_f_detach_waiting = 0;
+	mutex_exit(SD_MUTEX(un));
+
 	cmlb_detach(un->un_cmlbhandle, (void *)SD_PATH_DIRECT);
 	cmlb_free_handle(&un->un_cmlbhandle);
 
@@ -8936,6 +8671,16 @@
 		kstat_delete(un->un_stats);
 		un->un_stats = NULL;
 	}
+	if (un->un_unmapstats != NULL) {
+		kstat_delete(un->un_unmapstats_ks);
+		un->un_unmapstats_ks = NULL;
+		un->un_unmapstats = NULL;
+	}
+	if (un->un_lat_ksp != NULL) {
+		kstat_delete(un->un_lat_ksp);
+		un->un_lat_stats = NULL;
+		un->un_lat_ksp = NULL;
+	}
 	if (un->un_errstats != NULL) {
 		kstat_delete(un->un_errstats);
 		un->un_errstats = NULL;
@@ -8966,6 +8711,9 @@
 	/* Open/close semaphore */
 	sema_destroy(&un->un_semoclose);
 
+	/* Used to wait for outstanding commands */
+	cv_destroy(&un->un_detach_cv);
+
 	/* Removable media condvar. */
 	cv_destroy(&un->un_state_cv);
 
@@ -9001,20 +8749,20 @@
 		sd_scsi_update_lun_on_target(pdip, tgt, SD_SCSI_LUN_DETACH);
 	}
 
+	ddi_remove_minor_node(devi, NULL);
+	(void) devfs_clean(devi, NULL, DV_CLEAN_FORCE);
+
 	return (DDI_SUCCESS);
 
 err_notclosed:
 	mutex_exit(SD_MUTEX(un));
 
-err_stillbusy:
-	_NOTE(NO_COMPETING_THREADS_NOW);
-
 err_remove_event:
 	mutex_enter(&sd_detach_mutex);
 	un->un_detach_count--;
 	mutex_exit(&sd_detach_mutex);
 
-	SD_TRACE(SD_LOG_ATTACH_DETACH, un, "sd_unit_detach: exit failure\n");
+	SD_TRACE(SD_LOG_ATTACH_DETACH, un, "%s: exit failure\n", __func__);
 	return (DDI_FAILURE);
 }
 
@@ -9221,9 +8969,8 @@
 
 	instance = ddi_get_instance(SD_DEVINFO(un));
 
-	/* Note:x86: is this a VTOC8/VTOC16 difference? */
+	/* XXX is this a VTOC8/VTOC16 difference? */
 	for (i = 0; i < NSDMAP; i++) {
-
 		if (cmlb_partinfo(un->un_cmlbhandle, i,
 		    &nblks, NULL, &partname, NULL, (void *)SD_PATH_DIRECT) != 0)
 			continue;
@@ -9248,108 +8995,7 @@
 	}
 }
 
-
-#if (defined(__fibre))
 /*
- *    Function: sd_init_event_callbacks
- *
- * Description: This routine initializes the insertion and removal event
- *		callbacks. (fibre only)
- *
- *   Arguments: un - driver soft state (unit) structure
- *
- *     Context: Kernel thread context
- */
-
-static void
-sd_init_event_callbacks(struct sd_lun *un)
-{
-	ASSERT(un != NULL);
-
-	if ((un->un_insert_event == NULL) &&
-	    (ddi_get_eventcookie(SD_DEVINFO(un), FCAL_INSERT_EVENT,
-	    &un->un_insert_event) == DDI_SUCCESS)) {
-		/*
-		 * Add the callback for an insertion event
-		 */
-		(void) ddi_add_event_handler(SD_DEVINFO(un),
-		    un->un_insert_event, sd_event_callback, (void *)un,
-		    &(un->un_insert_cb_id));
-	}
-
-	if ((un->un_remove_event == NULL) &&
-	    (ddi_get_eventcookie(SD_DEVINFO(un), FCAL_REMOVE_EVENT,
-	    &un->un_remove_event) == DDI_SUCCESS)) {
-		/*
-		 * Add the callback for a removal event
-		 */
-		(void) ddi_add_event_handler(SD_DEVINFO(un),
-		    un->un_remove_event, sd_event_callback, (void *)un,
-		    &(un->un_remove_cb_id));
-	}
-}
-
-
-/*
- *    Function: sd_event_callback
- *
- * Description: This routine handles insert/remove events (photon). The
- *		state is changed to OFFLINE which can be used to supress
- *		error msgs. (fibre only)
- *
- *   Arguments: un - driver soft state (unit) structure
- *
- *     Context: Callout thread context
- */
-/* ARGSUSED */
-static void
-sd_event_callback(dev_info_t *dip, ddi_eventcookie_t event, void *arg,
-    void *bus_impldata)
-{
-	struct sd_lun *un = (struct sd_lun *)arg;
-
-	_NOTE(DATA_READABLE_WITHOUT_LOCK(sd_lun::un_insert_event));
-	if (event == un->un_insert_event) {
-		SD_TRACE(SD_LOG_COMMON, un, "sd_event_callback: insert event");
-		mutex_enter(SD_MUTEX(un));
-		if (un->un_state == SD_STATE_OFFLINE) {
-			if (un->un_last_state != SD_STATE_SUSPENDED) {
-				un->un_state = un->un_last_state;
-			} else {
-				/*
-				 * We have gone through SUSPEND/RESUME while
-				 * we were offline. Restore the last state
-				 */
-				un->un_state = un->un_save_state;
-			}
-		}
-		mutex_exit(SD_MUTEX(un));
-
-	_NOTE(DATA_READABLE_WITHOUT_LOCK(sd_lun::un_remove_event));
-	} else if (event == un->un_remove_event) {
-		SD_TRACE(SD_LOG_COMMON, un, "sd_event_callback: remove event");
-		mutex_enter(SD_MUTEX(un));
-		/*
-		 * We need to handle an event callback that occurs during
-		 * the suspend operation, since we don't prevent it.
-		 */
-		if (un->un_state != SD_STATE_OFFLINE) {
-			if (un->un_state != SD_STATE_SUSPENDED) {
-				New_state(un, SD_STATE_OFFLINE);
-			} else {
-				un->un_last_state = SD_STATE_OFFLINE;
-			}
-		}
-		mutex_exit(SD_MUTEX(un));
-	} else {
-		scsi_log(SD_DEVINFO(un), sd_label, CE_NOTE,
-		    "!Unknown event\n");
-	}
-
-}
-#endif
-
-/*
  * Values related to caching mode page depending on whether the unit is ATAPI.
  */
 #define	SDC_CDB_GROUP(un) ((un->un_f_cfg_is_atapi == TRUE) ? \
@@ -9752,9 +9398,8 @@
 
 		if (rval == 0 && (inq86_len - inq86_resid > 6)) {
 			SD_TRACE(SD_LOG_COMMON, un,
-			    "sd_get_nv_sup: \
-			    successfully get VPD page: %x \
-			    PAGE LENGTH: %x BYTE 6: %x\n",
+			    "sd_get_nv_sup: successfully get VPD page: %x "
+			    "PAGE LENGTH: %x BYTE 6: %x\n",
 			    inq86[1], inq86[3], inq86[6]);
 
 			mutex_enter(SD_MUTEX(un));
@@ -10096,18 +9741,12 @@
 	 * if another thread somewhere is trying to detach the instance.
 	 */
 	if (((un = ddi_get_soft_state(sd_state, instance)) == NULL) ||
-	    (un->un_detach_count != 0)) {
+	    un->un_detach_count != 0 || DEVI_IS_GONE(SD_DEVINFO(un))) {
 		mutex_exit(&sd_detach_mutex);
 		/*
-		 * The probe cache only needs to be cleared when open (9e) fails
-		 * with ENXIO (4238046).
+		 * The probe cache only needs to be cleared when open (9E) fails
+		 * with ENXIO.
 		 */
-		/*
-		 * un-conditionally clearing probe cache is ok with
-		 * separate sd/ssd binaries
-		 * x86 platform can be an issue with both parallel
-		 * and fibre in 1 binary
-		 */
 		sd_scsi_clear_probe_cache();
 		return (ENXIO);
 	}
@@ -10158,10 +9797,10 @@
 
 	if (!nodelay) {
 		while ((un->un_state == SD_STATE_SUSPENDED) ||
-		    (un->un_state == SD_STATE_PM_CHANGING)) {
+		    (un->un_state == SD_STATE_PM_CHANGING) ||
+		    (un->un_state == SD_STATE_ATTACHING)) {
 			cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 		}
-
 		mutex_exit(SD_MUTEX(un));
 		if (sd_pm_entry(un) != DDI_SUCCESS) {
 			rval = EIO;
@@ -10170,6 +9809,12 @@
 			goto open_failed_with_pm;
 		}
 		mutex_enter(SD_MUTEX(un));
+	} else if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		rval = EIO;
+		SD_ERROR(SD_LOG_OPEN_CLOSE, un,
+		    "sdopen: attach failed, can't open\n");
+		goto open_failed_not_attached;
 	}
 
 	/* check for previous exclusive open */
@@ -10260,7 +9905,6 @@
 			    "device not ready or invalid disk block value\n");
 			goto open_fail;
 		}
-#if defined(__i386) || defined(__amd64)
 	} else {
 		uchar_t *cp;
 		/*
@@ -10281,8 +9925,6 @@
 			    (void *)SD_PATH_DIRECT);
 			mutex_enter(SD_MUTEX(un));
 		}
-
-#endif
 	}
 
 	if (otyp == OTYP_LYR) {
@@ -10326,6 +9968,12 @@
 	SD_TRACE(SD_LOG_OPEN_CLOSE, un, "sdopen: "
 	    "open of part %d type %d\n", part, otyp);
 
+	/*
+	 * If we made it here, the disk is alive.
+	 * Make sure it is set to normal state.
+	 */
+	New_state(un, SD_STATE_NORMAL);
+
 	mutex_exit(SD_MUTEX(un));
 	if (!nodelay) {
 		sd_pm_exit(un);
@@ -10354,6 +10002,7 @@
 		sd_pm_exit(un);
 	}
 open_failed_with_pm:
+open_failed_not_attached:
 	sema_v(&un->un_semoclose);
 
 	mutex_enter(&sd_detach_mutex);
@@ -10396,7 +10045,11 @@
 		return (ENXIO);
 	}
 
+	/* Hold the detach mutex to allow close to complete */
+	mutex_enter(&sd_detach_mutex);
+
 	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL) {
+		mutex_exit(&sd_detach_mutex);
 		return (ENXIO);
 	}
 
@@ -10414,8 +10067,9 @@
 
 	mutex_enter(SD_MUTEX(un));
 
-	/* Don't proceed if power is being changed. */
-	while (un->un_state == SD_STATE_PM_CHANGING) {
+	/* Don't proceed if power is being changed or we're still attaching. */
+	while ((un->un_state == SD_STATE_PM_CHANGING) ||
+	    (un->un_state == SD_STATE_ATTACHING)) {
 		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 	}
 
@@ -10456,8 +10110,7 @@
 			cmlb_invalidate(un->un_cmlbhandle,
 			    (void *)SD_PATH_DIRECT);
 			mutex_enter(SD_MUTEX(un));
-
-		} else {
+		} else if (un->un_state != SD_STATE_ATTACH_FAILED) {
 			/*
 			 * Flush any outstanding writes in NVRAM cache.
 			 * Note: SYNCHRONIZE CACHE is an optional SCSI-2
@@ -10471,18 +10124,11 @@
 			 * sending the Sync Cache command. If additional
 			 * commands are added which require a powered up
 			 * drive, the following sequence may have to change.
-			 *
-			 * And finally, note that parallel SCSI on SPARC
-			 * only issues a Sync Cache to DVD-RAM, a newly
-			 * supported device.
 			 */
-#if defined(__i386) || defined(__amd64)
-			if ((un->un_f_sync_cache_supported &&
+			if (!DEVI_IS_GONE(SD_DEVINFO(un)) &&
+			    ((un->un_f_sync_cache_supported &&
 			    un->un_f_sync_cache_required) ||
-			    un->un_f_dvdram_writable_device == TRUE) {
-#else
-			if (un->un_f_dvdram_writable_device == TRUE) {
-#endif
+			    un->un_f_dvdram_writable_device == TRUE)) {
 				mutex_exit(SD_MUTEX(un));
 				if (sd_pm_entry(un) == DDI_SUCCESS) {
 					rval =
@@ -10532,6 +10178,12 @@
 			}
 
 			/*
+			 * Pardon a device that is currently in failfast
+			 * active state, to not bias a future open.
+			 */
+			un->un_failfast_state = SD_FAILFAST_INACTIVE;
+
+			/*
 			 * If a device has removable media, invalidate all
 			 * parameters related to media, such as geometry,
 			 * blocksize, and blockcount.
@@ -10568,16 +10220,11 @@
 	mutex_exit(SD_MUTEX(un));
 	sema_v(&un->un_semoclose);
 
-	if (otyp == OTYP_LYR) {
-		mutex_enter(&sd_detach_mutex);
-		/*
-		 * The detach routine may run when the layer count
-		 * drops to zero.
-		 */
+	if (otyp == OTYP_LYR)
 		un->un_layer_count--;
-		mutex_exit(&sd_detach_mutex);
-	}
 
+	mutex_exit(&sd_detach_mutex);
+
 	return (rval);
 }
 
@@ -10673,7 +10320,7 @@
 		 */
 		mutex_exit(SD_MUTEX(un));
 
-		status = sd_send_scsi_TEST_UNIT_READY(ssc, 0);
+		status = sd_send_scsi_TEST_UNIT_READY(ssc, SD_DONT_RETRY_TUR);
 		if (status != 0) {
 			sd_ssc_assessment(ssc, SD_FMT_IGNORE);
 		}
@@ -10879,13 +10526,23 @@
 	int		err = 0;
 	sd_ssc_t	*ssc;
 
-	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL) {
+	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL ||
+	    DEVI_IS_GONE(SD_DEVINFO(un)))
 		return (ENXIO);
-	}
 
 	ASSERT(!mutex_owned(SD_MUTEX(un)));
 
+	mutex_enter(SD_MUTEX(un));
+	while (un->un_state == SD_STATE_ATTACHING)
+		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		SD_ERROR(SD_LOG_READ_WRITE, un, "sdread: attach failed\n");
+		return (EIO);
+	}
+	mutex_exit(SD_MUTEX(un));
+
 	if (!SD_IS_VALID_LABEL(un) && !ISCD(un)) {
 		mutex_enter(SD_MUTEX(un));
 		/*
@@ -10897,6 +10554,8 @@
 		    (un->un_state == SD_STATE_PM_CHANGING)) {
 			cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 		}
+
+		SD_BAIL_CHECK(un);
 		un->un_ncmds_in_driver++;
 		mutex_exit(SD_MUTEX(un));
 
@@ -10911,6 +10570,8 @@
 
 		mutex_enter(SD_MUTEX(un));
 		un->un_ncmds_in_driver--;
+		if (un->un_f_detach_waiting)
+			cv_signal(&un->un_detach_cv);
 		ASSERT(un->un_ncmds_in_driver >= 0);
 		mutex_exit(SD_MUTEX(un));
 		if (err != 0)
@@ -10970,12 +10631,23 @@
 	int		err = 0;
 	sd_ssc_t	*ssc;
 
-	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL) {
+	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL ||
+	    DEVI_IS_GONE(SD_DEVINFO(un)))
 		return (ENXIO);
-	}
 
 	ASSERT(!mutex_owned(SD_MUTEX(un)));
 
+	mutex_enter(SD_MUTEX(un));
+	while (un->un_state == SD_STATE_ATTACHING)
+		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
+
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		SD_ERROR(SD_LOG_READ_WRITE, un, "sdwrite: attach failed\n");
+		return (EIO);
+	}
+	mutex_exit(SD_MUTEX(un));
+
 	if (!SD_IS_VALID_LABEL(un) && !ISCD(un)) {
 		mutex_enter(SD_MUTEX(un));
 		/*
@@ -10987,6 +10659,8 @@
 		    (un->un_state == SD_STATE_PM_CHANGING)) {
 			cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 		}
+
+		SD_BAIL_CHECK(un);
 		un->un_ncmds_in_driver++;
 		mutex_exit(SD_MUTEX(un));
 
@@ -11002,6 +10676,8 @@
 		mutex_enter(SD_MUTEX(un));
 		un->un_ncmds_in_driver--;
 		ASSERT(un->un_ncmds_in_driver >= 0);
+		if (un->un_f_detach_waiting)
+			cv_signal(&un->un_detach_cv);
 		mutex_exit(SD_MUTEX(un));
 		if (err != 0)
 			return (err);
@@ -11060,12 +10736,23 @@
 	int		err = 0;
 	sd_ssc_t	*ssc;
 
-	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL) {
+	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL ||
+	    DEVI_IS_GONE(SD_DEVINFO(un)))
 		return (ENXIO);
-	}
 
 	ASSERT(!mutex_owned(SD_MUTEX(un)));
 
+	mutex_enter(SD_MUTEX(un));
+	while (un->un_state == SD_STATE_ATTACHING)
+		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
+
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		SD_ERROR(SD_LOG_READ_WRITE, un, "sdaread: attach failed\n");
+		return (EIO);
+	}
+	mutex_exit(SD_MUTEX(un));
+
 	if (!SD_IS_VALID_LABEL(un) && !ISCD(un)) {
 		mutex_enter(SD_MUTEX(un));
 		/*
@@ -11077,6 +10764,8 @@
 		    (un->un_state == SD_STATE_PM_CHANGING)) {
 			cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 		}
+
+		SD_BAIL_CHECK(un);
 		un->un_ncmds_in_driver++;
 		mutex_exit(SD_MUTEX(un));
 
@@ -11092,6 +10781,8 @@
 		mutex_enter(SD_MUTEX(un));
 		un->un_ncmds_in_driver--;
 		ASSERT(un->un_ncmds_in_driver >= 0);
+		if (un->un_f_detach_waiting)
+			cv_signal(&un->un_detach_cv);
 		mutex_exit(SD_MUTEX(un));
 		if (err != 0)
 			return (err);
@@ -11150,12 +10841,24 @@
 	int		err = 0;
 	sd_ssc_t	*ssc;
 
-	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL) {
+	if ((un = ddi_get_soft_state(sd_state, SDUNIT(dev))) == NULL ||
+	    DEVI_IS_GONE(SD_DEVINFO(un)))
 		return (ENXIO);
-	}
 
 	ASSERT(!mutex_owned(SD_MUTEX(un)));
 
+	mutex_enter(SD_MUTEX(un));
+	while (un->un_state == SD_STATE_ATTACHING)
+		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
+
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		SD_ERROR(SD_LOG_READ_WRITE, un,
+		    "sdawrite: attach failed\n");
+		return (EIO);
+	}
+	mutex_exit(SD_MUTEX(un));
+
 	if (!SD_IS_VALID_LABEL(un) && !ISCD(un)) {
 		mutex_enter(SD_MUTEX(un));
 		/*
@@ -11167,6 +10870,8 @@
 		    (un->un_state == SD_STATE_PM_CHANGING)) {
 			cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 		}
+
+		SD_BAIL_CHECK(un);
 		un->un_ncmds_in_driver++;
 		mutex_exit(SD_MUTEX(un));
 
@@ -11182,6 +10887,8 @@
 		mutex_enter(SD_MUTEX(un));
 		un->un_ncmds_in_driver--;
 		ASSERT(un->un_ncmds_in_driver >= 0);
+		if (un->un_f_detach_waiting)
+			cv_signal(&un->un_detach_cv);
 		mutex_exit(SD_MUTEX(un));
 		if (err != 0)
 			return (err);
@@ -11311,40 +11018,6 @@
 
 
 /*
- * Create taskq for all targets in the system. This is created at
- * _init(9E) and destroyed at _fini(9E).
- *
- * Note: here we set the minalloc to a reasonably high number to ensure that
- * we will have an adequate supply of task entries available at interrupt time.
- * This is used in conjunction with the TASKQ_PREPOPULATE flag in
- * sd_create_taskq().  Since we do not want to sleep for allocations at
- * interrupt time, set maxalloc equal to minalloc. That way we will just fail
- * the command if we ever try to dispatch more than SD_TASKQ_MAXALLOC taskq
- * requests any one instant in time.
- */
-#define	SD_TASKQ_NUMTHREADS	8
-#define	SD_TASKQ_MINALLOC	256
-#define	SD_TASKQ_MAXALLOC	256
-
-static taskq_t	*sd_tq = NULL;
-_NOTE(SCHEME_PROTECTS_DATA("stable data", sd_tq))
-
-static int	sd_taskq_minalloc = SD_TASKQ_MINALLOC;
-static int	sd_taskq_maxalloc = SD_TASKQ_MAXALLOC;
-
-/*
- * The following task queue is being created for the write part of
- * read-modify-write of non-512 block size devices.
- * Limit the number of threads to 1 for now. This number has been chosen
- * considering the fact that it applies only to dvd ram drives/MO drives
- * currently. Performance for which is not main criteria at this stage.
- * Note: It needs to be explored if we can use a single taskq in future
- */
-#define	SD_WMR_TASKQ_NUMTHREADS	1
-static taskq_t	*sd_wmr_tq = NULL;
-_NOTE(SCHEME_PROTECTS_DATA("stable data", sd_wmr_tq))
-
-/*
  *    Function: sd_taskq_create
  *
  * Description: Create taskq thread(s) and preallocate task entries
@@ -11422,21 +11095,17 @@
 sdstrategy(struct buf *bp)
 {
 	struct sd_lun *un;
+	int error = EIO;
 
-	un = ddi_get_soft_state(sd_state, SD_GET_INSTANCE_FROM_BUF(bp));
-	if (un == NULL) {
-		bioerror(bp, EIO);
-		bp->b_resid = bp->b_bcount;
-		biodone(bp);
-		return (0);
-	}
+	if ((un = ddi_get_soft_state(sd_state,
+	    SD_GET_INSTANCE_FROM_BUF(bp))) == NULL)
+		goto fail;
 
-	/* As was done in the past, fail new cmds. if state is dumping. */
-	if (un->un_state == SD_STATE_DUMPING) {
-		bioerror(bp, ENXIO);
-		bp->b_resid = bp->b_bcount;
-		biodone(bp);
-		return (0);
+	/* Fail new cmds if state is dumping or device is gone */
+	if (un->un_state == SD_STATE_DUMPING ||
+	    DEVI_IS_GONE(SD_DEVINFO(un))) {
+		error = ENXIO;
+		goto fail;
 	}
 
 	ASSERT(!mutex_owned(SD_MUTEX(un)));
@@ -11453,10 +11122,22 @@
 	 * if it's power level is changing.
 	 */
 	while ((un->un_state == SD_STATE_SUSPENDED) ||
-	    (un->un_state == SD_STATE_PM_CHANGING)) {
+	    (un->un_state == SD_STATE_PM_CHANGING) ||
+	    (un->un_state == SD_STATE_ATTACHING)) {
 		cv_wait(&un->un_suspend_cv, SD_MUTEX(un));
 	}
 
+	if (un->un_state == SD_STATE_ATTACH_FAILED) {
+		mutex_exit(SD_MUTEX(un));
+		SD_ERROR(SD_LOG_READ_WRITE, un,
+		    "sdstrategy: attach failed\n");
+		goto fail;
+	}
+	if (un->un_detach_count != 0) {
+		mutex_exit(SD_MUTEX(un));
+		goto fail;
+	}
+
 	un->un_ncmds_in_driver++;
 
 	/*
@@ -11484,9 +11165,14 @@
 	 * imized tail call which saves us a stack frame.
 	 */
 	return (ddi_xbuf_qstrategy(bp, un->un_xbuf_attr));
+
+fail:
+	bioerror(bp, error);
+	bp->b_resid = bp->b_bcount;
+	biodone(bp);
+	return (0);
 }
 
-
 /*
  *    Function: sd_xbuf_strategy
  *
@@ -11669,7 +11355,7 @@
 	ASSERT(bp != NULL);
 
 	un = ddi_get_soft_state(sd_state, SD_GET_INSTANCE_FROM_BUF(bp));
-	if (un == NULL) {
+	if (un == NULL || DEVI_IS_GONE(SD_DEVINFO(un))) {
 		bioerror(bp, EIO);
 		bp->b_resid = bp->b_bcount;
 		biodone(bp);
@@ -11706,6 +11392,15 @@
 	    (cmd != SCMD_MODE_SELECT) && (cmd != SCMD_MODE_SELECT_G1))
 		un->un_f_sync_cache_required = TRUE;
 
+	if (sd_failfast_enable & SD_FAILFAST_ENABLE_FAIL_USCSI) {
+		/*
+		 * If there are outstanding commands, treat all
+		 * USCSI commands as if they have B_FAILFAST set.
+		 */
+		if (un->un_ncmds_in_driver != 1)
+			bp->b_flags |= B_FAILFAST;
+	}
+
 	mutex_exit(SD_MUTEX(un));
 
 	switch (uip->ui_flags) {
@@ -11780,9 +11475,8 @@
 	int		rval;
 
 	un = ddi_get_soft_state(sd_state, SDUNIT(dev));
-	if (un == NULL) {
+	if (un == NULL || DEVI_IS_GONE(SD_DEVINFO(un)))
 		return (ENXIO);
-	}
 
 	/*
 	 * Using sd_ssc_send to handle uscsi cmd
@@ -11949,6 +11643,7 @@
 	struct uscsi_cmd	*uscmd;
 	struct sd_lun		*un;
 	dev_t			dev;
+	dev_info_t		*dip = SD_DEVINFO(ssc->ssc_un);
 
 	int	format = 0;
 	int	rval;
@@ -11992,6 +11687,7 @@
 	 */
 	mutex_enter(SD_MUTEX(un));
 	mutex_enter(&un->un_pm_mutex);
+
 	if ((uscmd->uscsi_flags & USCSI_PMFAILFAST) &&
 	    SD_DEVICE_IS_IN_LOW_POWER(un)) {
 		SD_TRACE(SD_LOG_IO, un, "sd_ssc_send:"
@@ -12060,6 +11756,10 @@
 	dev = SD_GET_DEV(un);
 	rval = scsi_uscsi_handle_cmd(dev, dataspace, uscmd,
 	    sd_uscsi_strategy, NULL, uip);
+	if (DEVI_IS_GONE(dip)) {
+		cmn_err(CE_WARN, "%s-%d: device is gone!", __func__, __LINE__);
+		return (ENXIO);
+	}
 
 	/*
 	 * mark ssc_flags right after handle_cmd to make sure
@@ -12428,6 +12128,8 @@
 
 		un->un_ncmds_in_driver--;
 		ASSERT(un->un_ncmds_in_driver >= 0);
+		if (un->un_f_detach_waiting)
+			cv_signal(&un->un_detach_cv);
 		SD_INFO(SD_LOG_IO, un,
 		    "sd_buf_iodone: un_ncmds_in_driver = %ld\n",
 		    un->un_ncmds_in_driver);
